getconsole:
	jnb	ri,no_command	;
	call	getchr		;
	mov	r2,dpl		;
	mov	command,r2		;
	jmp	getconsoleRET	;

no_command:
	mov	command,#0ffh	;

getconsoleRET:
	ret				;
;--------------------------------------------
;use XON and XOFF for controlling flow with host 
chkXOFF:
	call	getconsole		;
	mov	r2,dpl		;
	mov	r3,dph		;
	cjne	r2,#XOFF,chkXOFFret ;
	cjne	r3,#000h,chkXOFFret ;

Wait_XON:
	call	getconsole		;loop until char = XON
	mov	r2,dpl		;
	mov	r3,dph		;
	cjne	r2,#XON,Wait_XON	;
	cjne	r3,#000h,Wait_XON ;

chkXOFFret:
	ret				;
;--------------------------------------------
getchar:
	jnb	ri,getchar		;
	clr	ri			;
	mov	dpl,sbuf		;
	call	putchar		;
	mov	dpl,sbuf		;
	ret				;
;---------------------------------------------
getchr:
	jnb	ri,getchr		;
	clr	ri			;
	mov	dpl,sbuf		;
	ret				;
;---------------------------------------------
;enter with char in dpl
putchar:
	mov	r2,dpl		;

putchar1:
	jnb	ti,putchar1		;
	clr	ti			;
	mov	sbuf,r2		;
	ret				;
;********************************************************************
; Send a null terminated string out serial port
;********************************************************************
putstr:
 	clr a
	movc a,@a+dptr	; get character
	jz putstr1		; stop if char == null

	push	dpl
	mov	dpl,a
	call putchar	; else send it
	pop	dpl

	inc dptr		; point to next char
	sjmp putstr
putstr1:
	ret
;---------------------------------------------------
sendprompt:
	mov	dptr,#prompt	;print string ">"
	call	putstr		;
	ret				;
;--------------------------------------------
prompting:
	mov	r2,command		;
	cjne	r2,#cr,promptingRET ;if command = 0Dh

	mov	dptr,#title		;print title string
	call	putstr		;
	call	sendprompt		;

promptingRET:
	ret				;
;--------------------------------------------
getnum:
	mov	r2,#000h		;
	mov	r3,#000h		;

getnumLoop:
	mov	004h,r2		;0 in r4
	cjne	r4,#lf,getnum2	;
	sjmp	getnum4		;0Ah = stop receiving bytes

getnum2:
	mov	dpl,#XON		;send xon to signal host to send byte
	push	002h			;
	push	003h			;
	call	putchar		;send XON
	pop	003h			;
	pop	002h			;

	push	002h			;
	push	003h			;
	call	getchar		;get character from serial port
	mov	r4,dpl		;into DPL, and R4
	pop	003h			;
	pop	002h			;

	mov	002h,r4		;copy char to R2
	mov	004h,r2		;and back to R4, where it is already?

	cjne	r4,#cr,getnum3	;is char 0Dh?
	mov	r2,#lf		;if it is, change it to 0Ah

getnum3:
	mov	a,r3			;mov counter to acc

	ADD	A,#042H
;	add	a,#getnum_s_1_1	;add offset to counter (starts at getnum_s_1_1)

	mov	r0,acc		;
	mov	@r0,002h		;save R2 (char) @R0
	inc	r3			;inc counter
	sjmp	getnumLoop		;

getnum4:
	dec	r3			;received 0Ah from PC
	mov	a,r3			;counter in R3

	ADD	A,#042H

	mov	r0,acc		;now R0 points to ram address
	mov	@r0,#000h		;put terminator at the end of string
	mov	r2,#000h		;r2-r4 = 0
	mov	r3,#000h		;
	mov	r4,#000h		;
;
getnum5:
	mov	a,r4			;

	ADD	A,#042H
	mov	r0,a			;
	mov	005h,@r0		;
	cjne	r5,#000h,getnum6	;do until end marker (00h)
	sjmp	getnumEnd		;
;
;convert ascii to integer 
getnum6:
	clr	a			;
	MOV	04FH,A		;high byte
	MOV	04EH,#00AH		;low byte

	mov	dpl,r2		;
	mov	dph,r3		;

	push	002h			;
	push	003h			;
	push	004h			;
	push	005h			;
	call	muluint		;
	mov	r6,dpl		;
	mov	r7,dph		;
	pop	005h			;
	pop	004h			;
	pop	003h			;
	pop	002h			;
	mov	a,r5			;
	rlc	a			;
	subb	a,acc			;
	mov	r0,a			;
	mov	a,r5			;
	add	a,r6			;
	mov	r6,a			;
	mov	a,r0			;
	addc	a,r7			;
	mov	r7,a			;
	mov	a,r6			;
	add	a,#0d0h		;
	mov	r2,a			;
	mov	a,r7			;
	addc	a,#0ffh		;
	mov	r3,a			;
	inc	r4			;
	sjmp	getnum5		;

getnumEnd:
	mov	dpl,r2		;return 16-bit for number of byte counting
	mov	dph,r3		;
	ret				;
;----------------------------------------
getcommand:
	jnb	ri,L01B5		;
	call	getchar		;
	mov	r2,dpl		;
	mov	command,r2		;
	sjmp	getcommandRET	;

L01B5:
	mov	command,#0ffh	;

getcommandRET:
	ret				;
;----------------------------------------
putok:
	mov	dptr,#ok		;send string "ok"
	call	putstr		;
	call	sendprompt		;
	ret				;
;--------------------------------------------
send_hex:
	mov	r2,dpl		;
	clr	c			;
	mov	a,#009h		;
	subb	a,r2			;
	jc	L01E3			;

	mov	a,#030h		;
	add	a,r2			;
	mov	r3,a			;
	mov	dpl,r3		;
	push	002h			;
	call	putchar		;
	pop	002h			;
	sjmp	L01EC			;

L01E3:
	mov	a,#037h		;
	add	a,r2			;
	mov	r2,a			;
	mov	dpl,r2		;
	call	putchar		;

L01EC:
	ret				;
;--------------------------------------------
puthex:
	mov	r2,dpl		;
	mov	a,#0f0h		;
	anl	a,r2			;
	mov	r3,a			;
	swap	a			;
	anl	a,#00fh		;
	mov	r3,a			;
	mov	dpl,r3		;
	push	002h			;
	push	003h			;
	call	send_hex		;
	pop	003h			;
	pop	002h			;
	mov	a,#00fh		;
	anl	a,r2			;
	mov	r3,a			;
	mov	dpl,r3		;
	call	send_hex		;
	ret				;
;--------------------------------------------
puthex16:
	mov	r2,dpl		;
	mov	r3,dph		;
	mov	004h,r3		;
	mov	r5,#000h		;
	mov	dpl,r4		;
	push	002h			;
	push	003h			;
	call	puthex		;
	pop	003h			;
	pop	002h			;
	mov	dpl,r2		;
	call	puthex		;
	ret				;
;--------------------------------------------
putnum:
	mov	r2,dpl		;
	mov	r3,dph		;

	MOV	04EH,#010H
	MOV	04FH,#027H

	mov	dpl,r2		;
	mov	dph,r3		;
	push	002h			;
	push	003h			;

	call	divuint		;

	mov	r4,dpl		;
	mov	r5,dph		;

	pop	003h			;
	pop	002h			;

	mov	a,#030h		;
	add	a,r4			;
	mov	r4,a			;
	clr	a			;
	addc	a,r5			;
	mov	r5,a			;

	MOV	048H,R4		; 
	MOV	04EH,#010H
	MOV	04FH,#027H

	mov	dpl,r2		;
	mov	dph,r3		;

	call	L0912			;

	mov	r2,dpl		;
	mov	r3,dph		;

	MOV	04EH,#0E8H		;
	MOV	04FH,#003H		;

	mov	dpl,r2		;
	mov	dph,r3		;
	push	002h			;
	push	003h			;

	call	divuint		;

	mov	r4,dpl		;
	mov	r5,dph		;
	pop	003h			;
	pop	002h			;
	mov	a,#030h		;
	add	a,r4			;
	mov	r4,a			;
	clr	a			;
	addc	a,r5			;
	mov	r5,a			;

	MOV	049H,R4		;
	MOV	04EH,#0E8H		;
	MOV	04FH,#003H		;

	mov	dpl,r2		;
	mov	dph,r3		;
	push	002h			;
	push	003h			;

	call	L0912			;

	mov	r4,dpl		;
	mov	r5,dph		;
	pop	003h			;
	pop	002h			;
	mov	002h,r4		;
	mov	003h,r5		;
	clr	a			;

	MOV	04FH,A		;
	MOV	04EH,#064H		;

	mov	dpl,r2		;
	mov	dph,r3		;
	push	002h			;
	push	003h			;

	call	divuint		;

	mov	r4,dpl		;
	mov	r5,dph		;
	pop	003h			;
	pop	002h			;
	mov	a,#030h		;
	add	a,r4			;
	mov	r4,a			;
	clr	a			;
	addc	a,r5			;
	mov	r5,a			;

	MOV	04AH,R4		;
	CLR	A			;
	MOV	04FH,A		;
	MOV	04EH,#064H		;

	mov	dpl,r2		;
	mov	dph,r3		;
	push	002h			;
	push	003h			;

	call	L0912			;

	mov	r4,dpl		;
	mov	r5,dph		;
	pop	003h			;
	pop	002h			;
	mov	002h,r4		;
	mov	003h,r5		;
	clr	a			;

	MOV	04FH,A		;
	MOV	04EH,#00AH		;

	mov	dpl,r2		;
	mov	dph,r3		;
	push	002h			;
	push	003h			;
	call	divuint		;
	mov	r4,dpl		;
	mov	r5,dph		;
	pop	003h			;
	pop	002h			;
	mov	a,#030h		;
	add	a,r4			;
	mov	r4,a			;
	clr	a			;
	addc	a,r5			;
	mov	r5,a			;

	MOV	04BH,R4		;
	CLR	A
	MOV	04FH,A
	MOV	04EH,#00AH

	mov	dpl,r2		;
	mov	dph,r3		;
	push	002h			;
	push	003h			;

	call	L0912			;

	mov	r4,dpl		;
	mov	r5,dph		;
	pop	003h			;
	pop	002h			;
	mov	002h,r4		;
	mov	003h,r5		;

	clr	a			;
	MOV	04FH,A		;
	MOV	04EH,#00AH

	mov	dpl,r2		;
	mov	dph,r3		;
	push	002h			;
	push	003h			;

	call	L0912			;

	mov	r4,dpl		;
	mov	r5,dph		;
	pop	003h			;
	pop	002h			;
	mov	a,#030h		;
	add	a,r4			;
	mov	r4,a			;
	clr	a			;
	addc	a,r5			;
	mov	r5,a			;

	mov	04ch,r4		;WATCH THIS HERE

	mov	r4,#000h		;
	mov	r5,#000h		;
;
L0343:
	mov	a,r4			;

	ADD	A,#048H		;

	mov	r0,a			;
	mov	006h,@r0		;
	cjne	r6,#030h,L035C	;
	clr	c			;
	mov	a,r4			;
	subb	a,#005h		;
	mov	a,r5			;
	subb	a,#000h		;
	jnc	L035C			;
	inc	r4			;
	cjne	r4,#000h,L0343	;
	inc	r5			;
	sjmp	L0343			;
;
L035C:
	mov	002h,r4		;
	mov	003h,r5		;
	cjne	r4,#005h,L036E	;
	cjne	r5,#000h,L036E	;
	mov	a,r4			;
	add	a,#0ffh		;
	mov	r2,a			;
	mov	a,r5			;
	addc	a,#0ffh		;
	mov	r3,a			;
;
L036E:
	mov	004h,r2		;
	mov	005h,r3		;
	inc	r2			;
	cjne	r2,#000h,L0377	;
	inc	r3			;
;
L0377:
	mov	a,r4			;

	ADD	A,#048H		;

	mov	r0,a			;
	mov	dpl,@r0		;
	push	002h			;
	push	003h			;
	call	putchar		;
	pop	003h			;
	pop	002h			;
	clr	c			;
	mov	a,r2			;
	subb	a,#005h		;
	mov	a,r3			;
	subb	a,#000h		;
	jc	L036E			;
	ret				;
;--------------------------------------------
